//*****************************************************************************
// File Name            : vin_adp.v
//-----------------------------------------------------------------------------
// Function             : vin_adp
//                        
//-----------------------------------------------------------------------------
// Designer             : yokomizo@himwari_co 
//-----------------------------------------------------------------------------
// History
// -.-- 2017/9/04
//*****************************************************************************
module vin_adp (
    iclk,
	idata,
	iadr,
	iwen,
	oclk,
	odata,
	oadr,
	owen,
	oack,
	rstb
	);

	input	  iclk;
	input	[15:0]  idata;
	input	[19:0]  iadr;
	input	  iwen;
	input	  oclk;
	output	[15:0]  odata;
	output	[19:0]  oadr;
	output	  owen;
	input	  oack;
    input rstb;
	
	wire aclr;
	wire iclk_b;
	wire [35:0]data;
	wire wrreq;
	wire [35:0]q;
	wire rdempty;
	wire rdreq;
	reg owen;
	assign iclk_b = ~iclk;
	assign aclr = ~rstb;
	assign data ={iadr,idata};
	assign wrreq = iwen;
	assign rdreq= ((owen==1'b0)&&(oack==1'b0)&&(rdempty==1'b0))?1'b1:1'b0;
	
	always@(posedge oclk)
	  if(rstb==1'b0)
	    owen <= 1'b0;
	  else
	    if(oack==1'b1)
	      owen <= 1'b0;
	    else if(rdempty==1'b0)	  
	      owen <= 1'b1;
		else
		  owen <= owen;
	
	/*
	always@(posedge oclk) //for test
	    owen <= 1'b0;
	*/
		
	assign odata = q[15:0];
	assign oadr  = q[35:16];
		 
 vin_fifo fifo_0(
	.data(data),
	.wrclk(iclk_b),
	.wrreq(wrreq),
	.rdclk(oclk),
	.rdreq(rdreq),
	.q(q),
	.rdempty(rdempty),
	.wrfull(wrfull)); 
	
endmodule
