//*****************************************************************************
// File Name            : hello_world_small.c
//-----------------------------------------------------------------------------
// Function             : camera set up
//
//-----------------------------------------------------------------------------
// Designer             : yokomizo@himwari_co
//-----------------------------------------------------------------------------
// History
// -.-- 2017/7/25
//*****************************************************************************
#include <stdio.h>
#include <stdint.h>
#include "system.h"
#include "altera_msgdma_descriptor_regs.h"
#include "altera_msgdma_csr_regs.h"
#include "altera_msgdma_response_regs.h"
// SDRAM Parameter
#define SDRAM_BASE NEW_SDRAM_CONTROLLER_0_BASE
#define FRAME_SIZE (4 * 800 * 480 ) // 
#define X_SIZE 800 //
#define Y_SIZE 480 //
// msgDAM Parameter
#define DESC_CONTROL (ALTERA_MSGDMA_DESCRIPTOR_CONTROL_GO_MASK|ALTERA_MSGDMA_DESCRIPTOR_CONTROL_PARK_READS_MASK | ALTERA_MSGDMA_DESCRIPTOR_CONTROL_GENERATE_SOP_MASK | ALTERA_MSGDMA_DESCRIPTOR_CONTROL_GENERATE_EOP_MASK)

int main()
{ int x,y;
  uint32_t *psdram;
  //[31:24]=pad [23:16]=reg, [15:8]=green [7:0]blue;
  // SDRAM Data Write
  for(y=0 ; y<Y_SIZE ; y++ )
	  for(x=0 ; x<X_SIZE ; x++ ){
	      psdram = (uint32_t*)(SDRAM_BASE + y*X_SIZE*4 + x*4);
		  if((x>=0)&&(x<200))
	        *psdram = 0x00ff0000; //red
		  else if((x>=200)&&(x<400))
		    *psdram = 0x0000ff00; //green
		  else if((x>=400)&&(x<600))
		    *psdram = 0x000000ff; //blue
	      else
	    	*psdram = 0x00807060; //gray
	  }
  //msgDMA contorol
  //msgDAM stop
  IOWR_ALTERA_MSGDMA_CSR_CONTROL(MSGDMA_0_CSR_BASE,0x5); //msgdma stop
  //set Descriptor
  IOWR_ALTERA_MSGDMA_DESCRIPTOR_READ_ADDRESS(MSGDMA_0_DESCRIPTOR_SLAVE_BASE,SDRAM_BASE);
  IOWR_ALTERA_MSGDMA_DESCRIPTOR_WRITE_ADDRESS(MSGDMA_0_DESCRIPTOR_SLAVE_BASE,0x0);
  IOWR_ALTERA_MSGDMA_DESCRIPTOR_LENGTH(MSGDMA_0_DESCRIPTOR_SLAVE_BASE,FRAME_SIZE);
  IOWR_ALTERA_MSGDMA_DESCRIPTOR_CONTROL_STANDARD(MSGDMA_0_DESCRIPTOR_SLAVE_BASE,DESC_CONTROL);
  //msgDMA start
  IOWR_ALTERA_MSGDMA_CSR_CONTROL(MSGDMA_0_CSR_BASE,0x0);
  while (1);
  return 0;
}
